/*		 ITI-FG  Kernel module free public release
 *
 *		     Copyright (C) 1996-2000 GOM mbH.
 *	         Rebenring 33, 38106 Braunschweig, GERMANY
 *		            All rights reserved
 *
 * $Id: iticonfig.y,v 7.0.2.2 2000/12/04 14:56:07 cvs Exp $
 *
 */

%{

#include <stdio.h>
#include <stddef.h>
#include <fcntl.h>
#include <strings.h>

#include "itifgExt.h"
#include "amvsReg.h"
#include "amdigReg.h"
#include "ampcvReg.h"
#include "icpciReg.h"
#include "pcdigReg.h"
#include "iticonfig.h"

int count = 0;

/* identifier - first/second parameter found */
int i_valid = FALSE, p_valid = FALSE, p2_valid = FALSE;

int board = -1, module = -1, camera = -1;

int presync_i = FALSE, presync_ii = FALSE, y_valid = FALSE;
int boardfound = FALSE, modulefound = FALSE, camerafound = FALSE,
  readout = FALSE;

char camera_name[MAX_ENTRY_LENGTH], exo_filename[MAX_ENTRY_LENGTH];

union iti_dev_t	*camcnf;

const struct iti_cnf_flag_t *iti_cnf_flag = NULL;
const struct iti_cnf_enum_t *iti_cnf_enum = NULL;
const struct iti_cnf_num_t *iti_cnf_num = NULL;

#ifdef DEBUG_ITIFG
const struct iti_cnf_flag_debug_t *iti_cnf_flag_debug = NULL;
const struct iti_cnf_enum_debug_t *iti_cnf_enum_debug = NULL;
const struct iti_cnf_num_debug_t *iti_cnf_num_debug = NULL;
#endif

extern FILE *yyin;

%}

%union
{
  long long_val;
  double double_val;
  char char_val[64];	/* MAX_ENTRY_LENGTH */
};


%token BOARD_0 BOARD_1 BOARD_2 BOARD_3
%token BRD_MOD_PCD_0 BRD_MOD_PCD_1 BRD_MOD_PCD_2 BRD_MOD_PCD_3
%token MODULE_FA MODULE_VS MODULE_C1 MODULE_DG MODULE_PV
%token CAMERA_0 CAMERA_1 CAMERA_2 CAMERA_3
%token EQUAL NEXT
%token <long_val> INTEGER
%token <double_val> FLOAT
%token <char_val> STRING
%token <char_val> QUOTE

%%

board:
	|	board_entry board
	;

board_entry:	board_begin parameter_list module
		{ presync_i = FALSE; }
	|	brd_mod_begin parameter_list
		{ presync_i = presync_ii = y_valid = FALSE; }
	;

board_begin:	BOARD_0
		{ if (board == 0) {
		    presync_i = boardfound = TRUE;
		  }
		}
	|	BOARD_1
		{ if (board == 1) {
		    presync_i = boardfound = TRUE;
		  }
		}
	|	BOARD_2
		{ if (board == 2) {
		    presync_i = boardfound = TRUE;
		  }
		}
	|	BOARD_3
		{ if (board == 3) {
		    presync_i = boardfound = TRUE;
		  }
		}
	;

brd_mod_begin:	BRD_MOD_PCD_0
		{ if (board == 0) {
		    presync_i = boardfound = TRUE;
		    if (presync_i && module == ITI_VMPCD)
		      presync_ii = modulefound = TRUE;
		    if (presync_ii && camera == 0)
		      readout = y_valid = camerafound = TRUE;
		    iti_cnf_flag = NULL;
		    iti_cnf_enum = pcd_cnf_enum;
		    iti_cnf_num = pcd_cnf_num;
#ifdef DEBUG_ITIFG
		    iti_cnf_flag_debug = NULL;
		    iti_cnf_enum_debug = NULL;
		    iti_cnf_num_debug = pcd_cnf_num_debug;
#endif
		  }
		}
	|	BRD_MOD_PCD_1
		{ if (board == 1) {
		    presync_i = boardfound = TRUE;
		    if (presync_i && module == ITI_VMPCD)
		      presync_ii = modulefound = TRUE;
		    if (presync_ii && camera == 0)
		      readout = y_valid = camerafound = TRUE;
		    iti_cnf_flag = NULL;
		    iti_cnf_enum = pcd_cnf_enum;
		    iti_cnf_num = pcd_cnf_num;
#ifdef DEBUG_ITIFG
		    iti_cnf_flag_debug = NULL;
		    iti_cnf_enum_debug = NULL;
		    iti_cnf_num_debug = pcd_cnf_num_debug;
#endif
		  }
		}
	|	BRD_MOD_PCD_2
		{ if (board == 2) {
		    presync_i = boardfound = TRUE;
		    if (presync_i && module == ITI_VMPCD)
		      presync_ii = modulefound = TRUE;
		    if (presync_ii && camera == 0)
		      readout = y_valid = camerafound = TRUE;
		    iti_cnf_flag = NULL;
		    iti_cnf_enum = pcd_cnf_enum;
		    iti_cnf_num = pcd_cnf_num;
#ifdef DEBUG_ITIFG
		    iti_cnf_flag_debug = NULL;
		    iti_cnf_enum_debug = NULL;
		    iti_cnf_num_debug = pcd_cnf_num_debug;
#endif
		  }
		}
	|	BRD_MOD_PCD_3
		{ if (board == 3) {
		    presync_i = boardfound = TRUE;
		    if (presync_i && module == ITI_VMPCD)
		      presync_ii = modulefound = TRUE;
		    if (presync_ii && camera == 0)
		      readout = y_valid = camerafound = TRUE;
		    iti_cnf_flag = NULL;
		    iti_cnf_enum = pcd_cnf_enum;
		    iti_cnf_num = pcd_cnf_num;
#ifdef DEBUG_ITIFG
		    iti_cnf_flag_debug = NULL;
		    iti_cnf_enum_debug = NULL;
		    iti_cnf_num_debug = pcd_cnf_num_debug;
#endif
		  }
		}
	;

module:		module_begin parameter_list camera
		{ presync_ii = FALSE; }
	;

module_begin:	MODULE_FA
		{ if (presync_i && module == ICP_AMFA) {
		    presync_ii = modulefound = TRUE;
		  }
		}
	|	MODULE_C1
		{ if (presync_i && module == ICP_AMC1) {
		    presync_ii = modulefound = TRUE;
		  }
		}
	|	MODULE_VS
		{ if (presync_i && module == ICP_AMVS) {
		    iti_cnf_flag = vs_cnf_flag;
		    iti_cnf_enum = vs_cnf_enum;
		    iti_cnf_num = vs_cnf_num;
#ifdef DEBUG_ITIFG
		    iti_cnf_flag_debug = vs_cnf_flag_debug;
		    iti_cnf_enum_debug = vs_cnf_enum_debug;
		    iti_cnf_num_debug = vs_cnf_num_debug;
#endif
		    presync_ii = modulefound = TRUE;
		  }
		}
	|	MODULE_DG
		{ if (presync_i && module == ICP_AMDG && camera == 0) {
		    iti_cnf_flag = dg_cnf_flag;
		    iti_cnf_enum = dg_cnf_enum;
		    iti_cnf_num = dg_cnf_num;
#ifdef DEBUG_ITIFG
		    iti_cnf_flag_debug = dg_cnf_flag_debug;
		    iti_cnf_enum_debug = dg_cnf_enum_debug;
		    iti_cnf_num_debug = dg_cnf_num_debug;
#endif
		    presync_ii = modulefound = TRUE;
		  }
		}
	|	MODULE_PV
		{ if (presync_i && module == ICP_AMPV) {
		    iti_cnf_flag = pv_cnf_flag;
		    iti_cnf_enum = NULL;
		    iti_cnf_num = pv_cnf_num;
#ifdef DEBUG_ITIFG
		    iti_cnf_flag_debug = NULL;
		    iti_cnf_enum_debug = NULL;
		    iti_cnf_num_debug = pv_cnf_num_debug;
#endif
		    presync_ii = modulefound = TRUE;
		  }
		}
	;

camera:
	|	camera_entry camera
	;

camera_entry:	camera_begin parameter_list
		{ y_valid = FALSE; }
	;

camera_begin:	CAMERA_0
		{ if (presync_ii && camera == 0) {
		    readout = y_valid = camerafound = TRUE;
		  }
		}
	|	CAMERA_1
		{ if (presync_ii && camera == 1) {
		    readout = y_valid = camerafound = TRUE;
		  }
		}
	|	CAMERA_2
		{ if (presync_ii && camera == 2) {
		    readout = y_valid = camerafound = TRUE;
		  }
		}
	|	CAMERA_3
		{ if (presync_ii && camera == 3) {
		    readout = y_valid = camerafound = TRUE;
		  }
		}
	;

parameter_list:
	|	parameter parameter_list
	;

parameter:	STRING
		{ if (y_valid && iti_cnf_flag != NULL)
		    {
		      while (*iti_cnf_flag[count].identifier != '\0')
			{
			  if (!strcmp (iti_cnf_flag[count].identifier, $1))
			    {
			      i_valid = TRUE;
#ifdef DEBUG_ITIFG
			      if (iti_cnf_flag_debug != NULL)
				ITI_PRINTF
				  ("\t\t%s: %s\n",
				   iti_cnf_flag_debug[count].reg_name,
				   iti_cnf_flag_debug[count].meaning);
#endif
			      switch (module)
				{
				case ICP_AMFA:
				  break;
				case ICP_AMC1:
				  break;
				case ICP_AMVS:
				  *((u_char*)((u_long)&camcnf->vs_cam +
					     iti_cnf_flag[count].offset)) =
				    iti_cnf_flag[count].value;
				  break;
				case ICP_AMDG:
				  *((u_char*)((u_long)&camcnf->dg_cam +
					      iti_cnf_flag[count].offset)) =
				    iti_cnf_flag[count].value;
				  break;
				case ICP_AMPV:
				  *((u_char*)((u_long)&camcnf->pv_cam +
					      iti_cnf_flag[count].offset)) =
				    iti_cnf_flag[count].value;
				  break;
				case ITI_VMPCD:
				  break;
				default:
				  return -EITI_FMT;
				}
			    }
			  count++;
			}
		      if (!i_valid)
			{
			  iti_printf ("%s\n", $1); 
			  return -EITI_FMT;
			}
		      i_valid = FALSE;
		      count = 0;
		    }
		}
	|	STRING EQUAL STRING
		{ if (y_valid && iti_cnf_enum != NULL)
		  {
		    while (*iti_cnf_enum[count].identifier != '\0')
		      {
			if (!strcmp (iti_cnf_enum[count].identifier, $1))
			  {
			    i_valid = TRUE;
			    if (!strcmp (iti_cnf_enum[count].parameter, $3))
			      {
				p_valid = TRUE;
#ifdef DEBUG_ITIFG
				if (iti_cnf_enum_debug != NULL)
				  ITI_PRINTF
				    ("\t\t%s: %s\n",
				     iti_cnf_enum_debug[count].reg_name,
				     iti_cnf_enum_debug[count].meaning);
#endif
				switch (module)
				  {
				  case ICP_AMFA:
				    break;
				  case ICP_AMC1:
				    break;
				  case ICP_AMVS:
				    *((u_char*)((u_long)&camcnf->vs_cam +
						iti_cnf_enum[count].offset)) =
				      iti_cnf_enum[count].value;
				    break;
				  case ICP_AMDG:
				    *((u_char*)((u_long)&camcnf->dg_cam +
						iti_cnf_enum[count].offset)) =
				      iti_cnf_enum[count].value;
				    break;
				  case ICP_AMPV:
				    break;
				  case ITI_VMPCD:
				    if (iti_cnf_enum[count].offset ==
					offsetof (struct pcd_cam_t, geometry))
				      /* this need special handling */
				      *((int*)((u_long)&camcnf->pcd_cam +
					       iti_cnf_enum[count].offset)) =
					iti_cnf_enum[count].value;
				    else
				      *((u_char*)((u_long)&camcnf->pcd_cam +
						  iti_cnf_enum[count].offset))=
					iti_cnf_enum[count].value;
				    break;
				  default:
				    return -EITI_FMT;
				  }
			      }
			  }
			count++;
		      }
		    if (!i_valid || !p_valid)
		      {
			iti_printf ("%s = %s\n", $1, $3); 
			return -EITI_FMT;
		      }
		    i_valid = p_valid = FALSE;
		    count = 0;
		  }
		}
	|	STRING EQUAL STRING NEXT STRING
		{ if (y_valid && iti_cnf_enum != NULL)
		  {
		    while (*iti_cnf_enum[count].identifier != '\0')
		      {
		      if (!strcmp (iti_cnf_enum[count].identifier, $1))
			{
			  i_valid = TRUE;
			  if (!strcmp (iti_cnf_enum[count].parameter, $3))
			    {
			      p_valid = TRUE;
#ifdef DEBUG_ITIFG
			      if (iti_cnf_enum_debug != NULL)
				ITI_PRINTF
				  ("\t\t%s: %s\n",
				   iti_cnf_enum_debug[count].reg_name,
				   iti_cnf_enum_debug[count].meaning);
#endif
			      switch (module)
				{
				case ICP_AMFA:
				  break;
				case ICP_AMC1:
				  break;
				case ICP_AMVS:
				  break;
				case ICP_AMDG:
				  break;
				case ICP_AMPV:
				  break;
				case ITI_VMPCD:
				  switch (iti_cnf_enum[count].offset)
				    {
				    case offsetof(struct pcd_cam_t, trig0pol):
				      camcnf->pcd_cam.trig0pol =
					iti_cnf_enum[count].value;
				      break;
				    case offsetof(struct pcd_cam_t, trig0src):
				      camcnf->pcd_cam.trig0src =
					iti_cnf_enum[count].value;
				      break;
				    case offsetof(struct pcd_cam_t, trig0gd):
				      camcnf->pcd_cam.trig0gd =
					iti_cnf_enum[count].value;
				      break;
				    default:
				      return -EITI_FMT;
				    }
				  break;
				default:
				  return -EITI_FMT;
				}
			    }
			  if (!strcmp (iti_cnf_enum[count].parameter, $5))
			    {
			      p2_valid = TRUE;
#ifdef DEBUG_ITIFG
			      if (iti_cnf_enum_debug != NULL)
				ITI_PRINTF
				  ("\t\t%s: %s\n",
				   iti_cnf_enum_debug[count].reg_name,
				   iti_cnf_enum_debug[count].meaning);
#endif
			      switch (module)
				{
				case ICP_AMFA:
				  break;
				case ICP_AMC1:
				  break;
				case ICP_AMVS:
				  break;
				case ICP_AMDG:
				  break;
				case ICP_AMPV:
				  break;
				case ITI_VMPCD:
				  switch (iti_cnf_enum[count].offset)
				    {
				    case offsetof(struct pcd_cam_t, trig0pol):
				      camcnf->pcd_cam.trig1pol =
					iti_cnf_enum[count].value;
				      break;
				    case offsetof(struct pcd_cam_t, trig0src):
				      camcnf->pcd_cam.trig1src =
					iti_cnf_enum[count].value;
				      break;
				    case offsetof(struct pcd_cam_t, trig0gd):
				      camcnf->pcd_cam.trig1gd =
					iti_cnf_enum[count].value;
				      break;
				    default:
				      return -EITI_FMT;
				    }
				  break;
				default:
				  return -EITI_FMT;
				}
			    }
			}
		      count++;
		      }
		    if (!i_valid || !p_valid || !p2_valid)
		      {
			iti_printf ("%s = %s,%s\n", $1, $3, $5); 
			return -EITI_FMT;
		      }
		    i_valid = p_valid = p2_valid = FALSE;
		    count = 0;
		  }
		}
	|	STRING EQUAL INTEGER
		{ if (y_valid && iti_cnf_num != NULL) {
		    while (*iti_cnf_num[count].identifier != '\0') {
		      if (!strcmp (iti_cnf_num[count].identifier, $1)) {
			i_valid = TRUE;
#ifdef DEBUG_ITIFG
			if (iti_cnf_num_debug != NULL)
			  ITI_PRINTF ("\t\t%s: %s= %d\n",
				      iti_cnf_num_debug[count].reg_name,
				      iti_cnf_num_debug[count].meaning, $3);
#endif
			switch (module) {
			case ICP_AMFA:
			  break;
			case ICP_AMC1:
			  break;
			case ICP_AMVS:
			  switch (count) {
			  case 0:
			    camcnf->vs_cam.strbdly = $3;
			    break;
			  case 1:
			    camcnf->vs_cam.hoff = $3;
			    break;
			  case 2:
			    camcnf->vs_cam.hsz = $3;
			    break;
			  case 3:
			    camcnf->vs_cam.voff = $3;
			    break;
			  case 4:
			    camcnf->vs_cam.vsz = $3;
			    break;
			  case 5:
			    camcnf->vs_cam.froff = $3;
			    break;
			  case 6:
			    camcnf->vs_cam.cppos = $3;
			    break;
			  case 7:
			    camcnf->vs_cam.nref =
			      (u_char)((float)$3/1200.0 * 256.0);
			    break;
			  case 8:
			    camcnf->vs_cam.pref =
			      (u_char)((float)$3/2000.0 * 256.0);
			    break;
			  default:
			    return -EITI_FMT;
			  }
			  break;
			case ICP_AMDG:
			  switch (count) {
			  case 0:
			    camcnf->dg_cam.mc = $3;
			    break;
			  case 1:
			    camcnf->dg_cam.extime = $3;
			    break;
			  case 2:
			    camcnf->dg_cam.hoff = $3;
			    break;
			  case 3:
			    camcnf->dg_cam.hact = $3;
			    break;
			  case 4:
			    camcnf->dg_cam.voff = $3;
			    break;
			  case 5:
			    camcnf->dg_cam.vact = $3;
			    break;
			  default:
			    return -EITI_FMT;
			  }
			  break;
			case ICP_AMPV:
			  switch (count) {
			  case 0:
			    camcnf->pv_cam.htotal = $3;
			    break;
			  case 1:
			    camcnf->pv_cam.hsyncpw = $3;
			    break;
			  case 2:
			    camcnf->pv_cam.hequipw = $3;
			    break;
			  case 3:
			    camcnf->pv_cam.hserrpw = $3;
			    break;
			  case 4:
			    camcnf->pv_cam.vtotal = $3;
			    break;
			  case 5:
			    camcnf->pv_cam.vsyncpw = $3;
			    break;
			  case 6:
			    camcnf->pv_cam.vgstart = $3;
			    break;
			  case 7:
			    camcnf->pv_cam.vgwidth = $3;
			    break;
			  case 8:
			    camcnf->pv_cam.hoffset = $3;
			    break;
			  case 9:
			    camcnf->pv_cam.hactive = $3;
			    break;
			  case 10:
			    camcnf->pv_cam.voffset = $3;
			    break;
			  case 11:
			    camcnf->pv_cam.vactive = $3;
			    break;
			  case 12:
			    camcnf->pv_cam.strbdly = $3;
			    break;
			  case 13:
			    camcnf->pv_cam.froff = $3;
			    break;
			  case 14:
			    camcnf->pv_cam.ccnt = $3;
			    break;
			  case 15:
			    camcnf->pv_cam.pref =
			      (u_char)((float)$3/2000.0 * 256.0);
			    break;
			  case 16:
			    camcnf->pv_cam.nref =
			      (u_char)((float)$3/1200.0 * 256.0);
			    break;
			  case 17:
			    camcnf->pv_cam.fdiv = $3;
			    break;
			  case 18:
			    camcnf->pv_cam.rdiv = $3;
			    break;
			  case 19:
			    camcnf->pv_cam.vcogain = $3;
			    break;
			  case 20:
			    camcnf->pv_cam.pda = $3;
			    break;
			  case 21:
			    camcnf->pv_cam.lcnt = $3;
			    break;
			  default:
			    return -EITI_FMT;
			  }
			  break;
			case ITI_VMPCD:
			  switch (count) {
			  case 0:
			    camcnf->pcd_cam.cammd = $3;
			    break;
			  case 1:
			    camcnf->pcd_cam.hoff = $3;
			    break;
			  case 2:
			    camcnf->pcd_cam.hact = $3;
			    break;
			  case 3:
			    camcnf->pcd_cam.voff = $3;
			    break;
			  case 4:
			    camcnf->pcd_cam.vact = $3;
			    break;
			  case 5:
			    camcnf->pcd_cam.lut0psz = ($3 - 8) / 2;
			    camcnf->pcd_cam.lut1psz = ($3 - 8) / 2;
			    break;
			  case 6:
			    camcnf->pcd_cam.trigdiv = $3;
			    break;
			  default:
			    return -EITI_FMT;
			  }
			  break;
			default:
			  return -EITI_FMT;
			}
		      }
		      count++;
		    }
		    if (!i_valid) {
		      iti_printf ("%s = %s\n", $1, $3); 
		      return -EITI_FMT;
		    }
		    i_valid = FALSE;
		    count = 0;
		  }
		}
	|	STRING EQUAL FLOAT
		{ if (y_valid && iti_cnf_num != NULL) {
		    while (*iti_cnf_num[count].identifier != '\0') {
		      if (!strcmp (iti_cnf_num[count].identifier, $1)) {
			i_valid = TRUE;
#ifdef DEBUG_ITIFG
			if (iti_cnf_num_debug != NULL)
			  ITI_PRINTF ("\t\t%s: %s= %f\n",
				      iti_cnf_num_debug[count].reg_name,
				      iti_cnf_num_debug[count].meaning, $3);
#endif
			switch (module) {
			case ICP_AMFA:
			  break;
			case ICP_AMC1:
			  break;
			case ICP_AMVS:
			  break;
			case ICP_AMDG:
			  break;
			case ICP_AMPV:
			  break;
			case ITI_VMPCD:
			  switch (count) {
			  case 7:
			    camcnf->pcd_cam.extime = $3;
			    break;
			  case 8:
			    camcnf->pcd_cam.cclkfreq = $3;
			    break;
			  case 9:
			  case 10:
			    camcnf->pcd_cam.rotime = $3;
			    break;
			  default:
			    return -EITI_FMT;
			  }
			  break;
			default:
			  return -EITI_FMT;
			}
		      }
		      count++;
		    }
		    if (!i_valid) {
		      iti_printf ("%s = %s\n", $1, $3); 
		      return -EITI_FMT;
		    }
		    i_valid = FALSE;
		    count = 0;
		  }
		}
	|	STRING EQUAL QUOTE
		{ if (y_valid) {
		    if (!strcmp ("Camera_Name", $1) ||
			!strcmp ("CAMERA_NAME", $1)) {
		      i_valid = TRUE;
		      ITI_PRINTF ("\t\tCamera_Name: %s\n", $3);
		      strcpy (camera_name, $3);
		    }
		    if (!strcmp ("Exo_Filename", $1) ||
			!strcmp ("EXO_FILENAME", $1)) {
		      i_valid = TRUE;
		      ITI_PRINTF ("\t\tExo_Filename: %s\n", $3);
		      strcpy (exo_filename, $3);
		    }
		    if (!i_valid) {
		      iti_printf ("%s = %s\n", $1, $3); 
		      return -EITI_FMT;
		    }
		    i_valid = FALSE;
		  }
		}
	;

%%

int
read_config (const char *config_file,
	     union iti_dev_t *config_camcnf,
	     int config_board,
	     int config_module,
             int config_camera,
	     char *config_camera_name,
	     char *config_exo_filename)
{
  int error;

  if ((yyin = fopen (config_file, "r" )) == NULL)
    return -EITI_ENT;

  camcnf = config_camcnf;
  board = config_board;
  module = config_module;
  camera = config_camera;
  
#ifdef YYDEBUG
  yydebug = 1;
#endif
  
  while (!feof(yyin))
    if ((error = yyparse()) < 0)
      return (error);
  
  /* error checking */
  
  if (!readout)
    {
      if (!boardfound)
	{
	  readout = modulefound = camerafound = FALSE;
	  return -EITI_ARG;
	}
      else
	{
	  if (!modulefound)
	    {
	      readout = boardfound = camerafound = FALSE;
	      return -EITI_ARG;
	    } 
	  else
	    {
	      if (!camerafound)
		{
		  readout = boardfound = modulefound = FALSE;
		  return -EITI_ARG;
		}
	    }
	}
    }
  
  if (config_camera_name)
    {
      memset (config_camera_name, '\0', MAX_ENTRY_LENGTH);
      if (strlen (camera_name) > 2)
	{
	  /* forget the double quotes */
	  strncpy (config_camera_name, camera_name + 1,
		   strlen (camera_name) - 2);
	}
    }
  if (config_exo_filename)
    {
      memset (config_exo_filename, '\0', MAX_ENTRY_LENGTH);
      if (strlen (exo_filename) > 2)
	{
	  /* forget the double quotes */
	  strncpy (config_exo_filename, exo_filename + 1,
		   strlen (exo_filename) - 2);
	}
    }
  
  readout = boardfound = modulefound = camerafound = FALSE;

  fclose (yyin);

  return (OK);
}

int
yyerror (char *s)
{
  ITI_PRINTF("\t\terror  : %s\n", s);
}

